// lab7.cpp : solution to extra credit lab

#include "stdafx.h"
#include <iostream>
#include <string>
using namespace std;

class crypt {
	public:
		crypt() { encrypted = "";}
		crypt(string str, int key);
		string decode(int key);    // return the decrypted string if key matches
	private:
		string encrypted;
		int key;
		char changechar(char c, char flag);
}; // crypt

crypt::crypt(string str, int k)
{
	key = k;
	for(int i = 0; i < str.length(); i++) {
		encrypted += changechar(str.at(i),'e');
	}
} // crypt constructor

// return the decrypted string if key matches
string 
crypt::decode(int k)
{
	string s="";
	if(k != key) return "Bad Key";

	for(int i = 0; i < encrypted.length(); i++) {
		s += changechar(encrypted.at(i),'d');
	}
	return s;
} // decode

// encrypts the letter using the key if flag is 'e'
// and decrypts if the flag is 'd'
char 
crypt::changechar(char c, char flag)
{
	char maxchar = 'z',minchar = 'a';

	// if upper case. change the min and max values
	if(( c > 'A') && ( c < 'Z')) {
		minchar = 'A'; maxchar = 'Z';
	}

	if(flag == 'e') { // encode
		if((c + key)  > maxchar) {  // need to wrap around
			// how far past the maxchar did we go?
			int offset = (c + key) - maxchar - 1;
			return minchar + offset; // count that far from the minchar
		}
		else {
			return c + key;  // no wrap
		}
	} // encode
	else {  // decode, reverse everything
		if((c - key)  < minchar) {  // need to wrap around
			// how far before the minchar did we go?
			int offset = minchar - (c - key) - 1;
			return maxchar - offset;
		}
		else {
			return c - key;  // no wrap
		}
	} // decode
} // changechar

int main(int argc, char* argv[])
{
	cout << "use a message that doesn't go past the end (abcd)" << endl;
	crypt one("abcde",3);
	cout << "with correct key: " << one.decode(3) << endl;
	cout << "with bad key: " << one.decode(6) << endl;

	cout << "now use a message that does go past the end (wxyz)" << endl;
	crypt two("wxyz",3);
	cout << "with correct key: " << two.decode(3) << endl;
	return 0;
}
